﻿# Message Box by gutemine extended by jjbig
# stolen from 3c5x9 ;-)
#
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.Button import Button

from twisted.internet import reactor
from twisted.web2 import server, channel, static, resource, stream, http_headers, responsecode, http

# Imports for the Enigma2 MessageBox Aperanc
#from Screens.MessageBox import MessageBox

import os, time, sys, traceback, string

import os
__version__ = "1.1"

class Message(resource.Resource):
    

    title = "DMM7025 MessageBox by gutemine extended by jjbig"
    yesnoFile = "/tmp/yesno"
     
    sessions = [ ]
    
    headStd = '''<html><head>
	<link href="/webdata/theme.css" type="text/css" rel="stylesheet"></link> 
	<meta content="text/html; charset=UTF-8" http-equiv="content-type">
	<meta content="no-cache" http-equiv="pragma">
	<meta content="0" http-equiv="expires">
	<meta content="no-cache" http-equiv="cache-control">'''
    
    
    def __init__(self,sessions):
        self.sessions = sessions
        
    def yesnoAnswer(self, confirmed):
    	yesnoFile = self.yesnoFile
    	yesnoFile = "%s" % self.yesnoFile
    	
    	if not confirmed:
    		cmdstr = "echo no > %s" % yesnoFile
		os.system(cmdstr) 
	else:
		cmdstr = "echo yes > %s" % yesnoFile
		os.system(cmdstr)
	print confirmed

    def render(self, req):
        """ rendering server response """
        command = req.args.get("message",None)
        getAnswer = req.args.get("getAnswer",None)
        title = self.title
        headStd = self.headStd
        yesnoFile = self.yesnoFile
        
        fehler = ""

        if command is None:
        	title = self.title
		html  = '''%(headStd)s
	<title>%(title)s</title>
</head><body>
<table border=0 cellpadding=0 cellspacing=10>
<form method="GET">
<tr><td>Message: <input name="message" type="text" size="50" maxlength="50"></td></tr>
<tr>
	<td><input type="radio" name="type"  value="yesno"> YES/NO (timeout=yes) </td>
	<td><input type="radio" name="type"  value="info" checked> Info</td>
	<td><input type="radio" name="type"  value="warning"> Warning</td>
</tr>
<tr>
	<td>Timeout:</td>
	<td>
		<select name="timeout" size="1">
			<option>5</option>
			<option>10</option>
			<option>15</option>
			<option>20</option>
		</select>
	</td>
</tr>
<!-- <tr>
	<td>Position:</td>
	<td>
	<table border=0 cellpadding=1 cellspacing=10>
	<tr>
		<td><input type="radio" name="position"  value="northEast"></td>
		<td><input type="radio" name="position"  value="north"></td>
		<td><input type="radio" name="position"  value="northWest"></td>
	<tr>
	<tr>
		<td><input type="radio" name="position"  value="west"></td>
		<td><input type="radio" name="position"  value="center" checked></td>
		<td><input type="radio" name="position"  value="east"></td>
	<tr>
	<tr>
		<td><input type="radio" name="position"  value="southEast"></td>
		<td><input type="radio" name="position"  value="south"></td>
		<td><input type="radio" name="position"  value="southWest"></td>
	<tr>
	
	</table>
	</td>
</tr> -->
<tr>
	<td><input type="submit" size="100px" value="Send"></td>
	<td><input type="reset" size="100px" value="Clear"></td>
</form>
</table>
%(fehler)s
</body></html>''' % locals()

        	return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
        elif getAnswer is not None:
        	messagetxt = str(req.args.get("message","0")[0])
        	answer = ""
        	if os.path.exists(yesnoFile) == True:
	        	file = open(yesnoFile, "r")
			lines = file.readlines()
			file.close()
			cmdstr = "rm %s" % yesnoFile
			os.system(cmdstr)
		
			answer = lines[0]
		else:
			answer = "There was no file and therefor no answer, sorry, somthing went wrong"
        	
		html  = '''%(headStd)s
	<title>%(title)s</title>
</head><body>
<h1><center>Message was send</center></h1>
<p><b>Answer is %(answer)s</p>
<p>Message was &quot;%(messagetxt)s&quot;</p>
%(fehler)s
</body></html>''' % locals()
		return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
        else:
		messagetxt = str(req.args.get("message","0")[0])
		type = str(req.args.get("type","0")[0])
		position = str(req.args.get("position","0")[0])
		timeout = int(req.args.get("timeout","20")[0])
		
		try:            
			#self.sessions[0].current_dialog.doClose()
			if type == "yesno":
            			self.sessions[0].openWithCallback(self.yesnoAnswer, MessageBox, messagetxt, type = MessageBox.TYPE_YESNO ,timeout = timeout)
            			html  = '''%(headStd)s
	<title>%(title)s</title>
	<meta http-equiv="Refresh" content="%(timeout)s; URL=/message?message=%(messagetxt)s&getAnswer=yes">
</head><body>
<h1><center>Question was sent you will be forwarded in %(timeout)s Seconds</center></h1>
%(fehler)s
</body></html>''' % locals()
            			return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
			elif type == "warning":
				self.sessions[0].open(MessageBox, messagetxt, type = MessageBox.TYPE_INFO ,timeout = timeout)
			else:
				self.sessions[0].open(MessageBox, messagetxt, type = MessageBox.TYPE_WARNING ,timeout = timeout)
            
		except:
            		etype = sys.exc_info()[0]
            		evalue = sys.exc_info()[1]
            		etb = traceback.extract_tb(sys.exc_info()[2])
            		fehler += "<p>Fehler beim erstellen des Timereintrags:(%s), evalue:(%s), etb:(%s)</p>" % (etype, evalue, etb)
            
		html  = '''%(headStd)s
	<meta http-equiv="Refresh" content="%(timeout)s; URL=/">
	<title>%(title)s</title>
</head><body>
<h1><center>Message was send</center></h1>
<p>Don't use Messagebox again before these %(timeout)s seconds!</p>
%(fehler)s
</body></html>''' % locals()
		return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)

	    #self.sessions[0].openWithCallback(MessageBox,"%s" % messagetxt, type = MessageBox.TYPE_INFO ,timeout = 20)
	    
	    