<!--

/*
 * A javascript that embeds a VLC player for Firefox and Internet Explorer
 * Copyright (C) 2006  Patrik Tast
 * http://www.ptast.com
 * email: patrik@ptast.com
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.	
 * 
 */


function buildplayer(target, width, height)
{
 var browsertype; // firefox = 1, IE = 2

  browsertype = checkbrowser();
  
  switch(browsertype) {
     case 1: buildfirefoxplayer(target, width, height); break;
     case 2: buildieplayer(target, width, height); break;

     default:
        alert("Supported browsers are Mozilla Firefox and Internet Exploder.\n\nGet Firefox!");
  }  
}

function checkbrowser()
{
 var useragent = navigator.userAgent.toLowerCase();
	
  if(useragent.indexOf("firefox") != -1) 	
     return 1;
  else if(useragent.indexOf("msie") != -1) 
     return 2;
  else
     return -1;
}

function uniqueplayername()
{
 var adate = new Date();
 
 return ("player" + adate.getTime());
}

function buildfirefoxplayer(target, width, height)
{
 var player = uniqueplayername();
 var html;
  
  html = "<p style=\"margin:5px auto auto auto;\">\n" + 
         "  <embed type=\"application\/x-vlc-plugin\"\n" +
         "    name=\"" + player + "\"\n" + 
         "    autoplay=\"yes\" loop=\"yes\"\n" + 
         "    width=\"" + width + "\"\n" +
         "    height=\"" + height + "\"\n" +
         "    target=\"" + target + "\">\n" +
         "  <\/embed>\n" + 
         "<\/p>" +
         "<div class=\"menu\" style=\"margin-top:45px;margin-bottom:0px;\">\n" + 
            addmenubuttons_FF(player) + 
         "<\/div>\n";
         
//  alert(html);

  document.write(html);  
}
 
function buildieplayer(target, width, height) 
{
 var player = uniqueplayername();
 var html;
         
  html = "<p style=\"margin:5px auto auto auto;\">\n" + 
         "  <OBJECT classid=\"clsid:E23FE9C6-778E-49D4-B537-38FCDE4887D8\"\n" + 
         "          codebase=\"cab/axvlc.cab\"\n" + 
         "          width=\"" + width + "\"\n" + 
         "          height=\""+ height +"\"\n" + 
         "          id=\""+ player +"\"\n" + 
         "          events=\"False\" VIEWASTEXT>\n" + 
         "    <param name=\"Src\" value=\""+ target +"\" \/>\n" + 
         "    <param name=\"ShowDisplay\" value=\"True\" \/>\n" + 
         "    <param name=\"AutoLoop\" value=\"False\" \/>\n" + 
         "    <param name=\"AutoPlay\" value=\"False\" \/>\n" + 
         "  <\/OBJECT>\n" + 
         "<\/p>\n" +    
         "<div class=\"menu\" style=\"margin-top:45px;margin-bottom:0px;\">\n" + 
            addmenubuttons_IE(player) + 
         "<\/div>\n";
     
 // alert(html);       
  
  document.write(html);
}

function addmenubuttons_IE(playername)
{
 var buttons;

 buttons = "<a href=\"javascript:;\" onClick=\"document." + playername + ".play()\" title=\"Play\">Play<\/a> | <a href=\"javascript:;\" onClick=\"document." + playername + ".pause()\" title=\"Pause\">Pause<\/a> | <a href=\"javascript:;\" onClick=\"document." + playername + ".stop()\" title=\"Stop\">Stop<\/a> | <a href=\"javascript:;\" onClick=\"document." + playername + ".toggleMute()\" title=\"Mute\">Mute<\/a> | <a href=\"javascript:;\" onClick=\"document." + playername + ".fullscreen()\" title=\"Fullscreen\">Fullscreen<\/a>";
 return buttons;
}

function addmenubuttons_FF(playername)
{
 var buttons;

 buttons = "<a href=\"javascript:;\" onClick=\"document." + playername + ".play()\" title=\"Play\">Play<\/a> | <a href=\"javascript:;\" onClick=\"document." + playername + ".pause()\" title=\"Pause\">Pause<\/a> | <a href=\"javascript:;\" onClick=\"document." + playername + ".stop()\" title=\"Stop\">Stop<\/a> | <a href=\"javascript:;\" onClick=\"document." + playername + ".mute()\" title=\"Mute\">Mute<\/a> | <a href=\"javascript:;\" onClick=\"document." + playername + ".fullscreen()\" title=\"Fullscreen\">Fullscreen<\/a>";
 return buttons;
}
// -->