# Movie Player by homey and others ...
from twisted.internet import reactor
from twisted.web2 import server, channel, static, resource, stream, http_headers, responsecode, http

from Components.FileList import FileEntryComponent, FileList
from Components.MediaPlayer import PlayList, PlaylistEntryComponent
from Tools.Directories import resolveFilename, SCOPE_MEDIA, SCOPE_CONFIG, SCOPE_SKIN_IMAGE

import os

__version__ = "0.1"

class MoviePlayer(resource.Resource):
    
    title = "DreamBox 7025 - Movie Player"
    sessions = [ ]

    def __init__(self,sessions):
    	self.sessions=sessions

    def render(self, req):
    	
#    	filelist = FileList(resolveFilename(SCOPE_MEDIA), matchingPattern = "(?i)^.*\.(mp3|ogg|ts|wav|wave|m3u|pls|e2pls|mpg|vob)", useServiceRef = True)
#    	filelist.selectionEnabled(1)
#    	text = os.path.dirname(filelist.getSelection()[0].getPath())

    	html  = "<html><head><title>%s</title><link href=\"/webdata/theme.css\" type=\"text/css\" rel=\"stylesheet\"></link><script type=\"text/javascript\" src=\"/webdata/vlcplayer.js\"></script></head>" %self.title
    	html += "<body>" 
    	html += "<table align=\"center\" border=\"0\" width=\"100%\">"
    	html += "<tr>"
    	html += "<td align=\"center\">"
#    	html += "File List: %s" %text
    	html += "</td>"
    	html += "</tr>"
    	html +="</table>"
    	html +="</body>"
    	html +="</html>"

    	return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
           