﻿# AddTimer by gutemine extremly extended by jjbig
# Del/Edit and List-Timer by jjbig
# many ideas where stolen from 3c5x9 ;-)

import os, time, sys, traceback, string
import NavigationInstance
from twisted.internet import reactor
from twisted.web2 import server, channel, static, resource, stream, http_headers, responsecode, http
from enigma import eServiceReference, eServiceCenter
from ServiceReference import ServiceReference
from RecordTimer import RecordTimerEntry, RecordTimer, AFTEREVENT
from Components.config import config

__version__ = "0.21.4"
version = __version__

#tar czf /tmp/WITimers-v0.21.3.tar.gz /usr/lib/enigma2/python/Plugins/Extensions/WebInterface/WITimers.py /usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/gfx/edit.gif /usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/gfx/trash.gif /usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/gfx/on.png /usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/gfx/off.png /usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/tools.js /usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/WITimers.js
# debug 
#  init 2
#  killall -9 enigma2
#  enigma2

class AddTimer(resource.Resource):

    #version = self.version
    title = "DMM7025 Add Timer (v%s)" % version
    sessions = [ ]
    
    def __init__(self,sessions):
    	self.sessions=sessions
    
    def render(self, req):
        """ rendering server response """
        title = self.title
        
        fehler = ""
        html = ""
        htmlok = ""
        headStd = '''<html><head>
	<link href="/webdata/theme.css" type="text/css" rel="stylesheet"></link> 
	<meta content="text/html; charset=UTF-8" http-equiv="content-type">
	<meta content="no-cache" http-equiv="pragma">
	<meta content="0" http-equiv="expires">
	<meta content="no-cache" http-equiv="cache-control">'''
        
        command   = str(req.args.get("command",  ["mainpage"])[0])
        
        # if debug is set, the WebPages show all the Parameters
        debug   = int(req.args.get("debug", "0")[0])
        #debug = 1

        
        
        ref = str(req.args.get("ref",[""])[0])
        refName = ""
        #print "ref1: %s" % ref
        
        program = string.split(ref, '|')
        if len(program) > 1:
            	ref = program[1]
            	refName = program[0]
        
        #print "ref1: %s" % ref
        
        #descr   = unicode(str(req.args.get("descr", [""])[0]))
        #name  = unicode(str(req.args.get("name", [""])[0]))
        descr   = str(req.args.get("descr", [""])[0])
        name  = str(req.args.get("name", [""])[0])
        
        useMargin = int(req.args.get("useMargin", "0")[0])
        		
        action   = str(req.args.get("action", [""])[0])
        repeated   = int(req.args.get("repeated", "0")[0])
        
        after_event = str(req.args.get("after_event",  [""])[0])
            
        eventid   = str(req.args.get("id",  [""])[0])
        
        start  = float(req.args.get("start", "0")[0])
        stop   = float(req.args.get("stop", "0")[0])
                
	sday    = int(req.args.get("sday",   "0")[0])
	smonth  = int(req.args.get("smonth", "0")[0])
	syear   = int(req.args.get("syear",  "0")[0])
	shour   = int(req.args.get("shour",  "0")[0])
	smin    = int(req.args.get("smin",   "0")[0])
	
	eday    = int(req.args.get("eday",   "0")[0])
	emonth  = int(req.args.get("emonth", "0")[0])
	eyear   = int(req.args.get("eyear",  "0")[0])
	ehour   = int(req.args.get("ehour",  "0")[0])
	emin    = int(req.args.get("emin",   "0")[0])
	
	mo   = int(req.args.get("mo", "0")[0])
        tu   = int(req.args.get("tu", "0")[0])
	we   = int(req.args.get("we", "0")[0])
	th   = int(req.args.get("th", "0")[0])
	fr   = int(req.args.get("fr", "0")[0])
	sa   = int(req.args.get("sa", "0")[0])
	su   = int(req.args.get("su", "0")[0])
	mf   = int(req.args.get("mf", "0")[0])
	
	if sday != 0:
		start = int( time.strftime("%s",  time.localtime(time.mktime( (syear, smonth, sday, shour, smin, 0, 0, 0, 0) ) ) ) )
			
		stop  = int( time.strftime("%s",  time.localtime(time.mktime( (eyear, emonth, eday, ehour, emin, 0, 0, 0, 0) ) ) ) )
		
		if useMargin == 1:
			start -= int(config.recording.margin_before.value) * 60
			stop  += int(config.recording.margin_after.value) * 60

        dstart = time.asctime(time.localtime(start))
	dstop  = time.asctime(time.localtime(stop))
	
	sdayOld  = int(req.args.get("sdayOld", "0")[0])
	smonthOld  = int(req.args.get("smonthOld", "0")[0])
	syearOld  = int(req.args.get("syearOld", "0")[0])
	shourOld  = int(req.args.get("shourOld", "0")[0])
	sminOld  = int(req.args.get("sminOld", "0")[0])
	
	edayOld  = int(req.args.get("edayOld", "0")[0])
	emonthOld  = int(req.args.get("emonthOld", "0")[0])
	eyearOld  = int(req.args.get("eyearOld", "0")[0])
	ehourOld  = int(req.args.get("ehourOld", "0")[0])
	eminOld  = int(req.args.get("eminOld", "0")[0])
	
	startOld = float(req.args.get("startOld", "0")[0])
	stopOld = float(req.args.get("stopOld", "0")[0])
	
	if sdayOld != 0:
		startOld = int( time.strftime("%s",  time.localtime(time.mktime( (syearOld, smonthOld, sdayOld, shourOld, sminOld, 0, 0, 0, 0) ) ) ) )
		stopOld  = int( time.strftime("%s",  time.localtime(time.mktime( (eyearOld, emonthOld, edayOld, ehourOld, eminOld, 0, 0, 0, 0) ) ) ) )
		
		if useMargin == 1:
			startOld -= int(config.recording.margin_before.value) * 60
			stopOld  += int(config.recording.margin_after.value) * 60
		
		
	editFields = '<input type="hidden" name="command" value="save">'
	if start != 0:
		editFields = '''
<input type="hidden" name="refOld" value="%(ref)s">
<input type="hidden" name="sdayOld" value="%(sday)s">
<input type="hidden" name="smonthOld" value="%(smonth)s">
<input type="hidden" name="syearOld" value="%(syear)s">
<input type="hidden" name="shourOld" value="%(shour)s">
<input type="hidden" name="sminOld" value="%(smin)s">
<input type="hidden" name="edayOld" value="%(eday)s">
<input type="hidden" name="emonthOld" value="%(emonth)s">
<input type="hidden" name="eyearOld" value="%(eyear)s">
<input type="hidden" name="ehourOld" value="%(ehour)s">
<input type="hidden" name="eminOld" value="%(emin)s">
<input type="hidden" name="command" value="deleteOld">''' % locals()
		for x in self.sessions[0].nav.RecordTimer.timer_list + self.sessions[0].nav.RecordTimer.processed_timers:
			service_ref = x.service_ref
			if str(service_ref) == str(ref):
				serviceRef = service_ref
				assert isinstance(serviceRef, ServiceReference)
				refName = str( serviceRef.getServiceName() )
				break

	if debug == 1:
		fehler += '''
command: %(command)s<br>
debug: %(debug)s<br>
name: %(name)s<br>
ref: %(ref)s<br>
refName: %(refName)s<br>
descr: %(descr)s<br>
action: %(action)s<br>
repeated: %(repeated)s<br>
after_event: %(after_event)s<br>
eventid: %(eventid)s<br>
start: %(start)s<br>
stop: %(stop)s<br>
sday: %(sday)s<br>
smonth: %(smonth)s<br>
syear: %(syear)s<br>
shour: %(shour)s<br>
smin: %(smin)s<br>
eday: %(eday)s<br>
emonth: %(emonth)s<br>
eyear: %(eyear)s<br>
ehour: %(ehour)s<br>
emin: %(emin)s<br>
mo: %(mo)s<br>
tu: %(tu)s<br>
we: %(we)s<br>
th: %(th)s<br>
fr: %(fr)s<br>
sa: %(sa)s<br>
su: %(su)s<br>
mf: %(mf)s<br>
dstart: %(dstart)s<br>
dstop: %(dstop)s<br>
sdayOld: %(sdayOld)s<br>
smonthOld: %(smonthOld)s<br>
syearOld: %(syearOld)s<br>
shourOld: %(shourOld)s<br>
sminOld: %(sminOld)s<br>
edayOld: %(edayOld)s<br>
emonthOld: %(emonthOld)s<br>
eyearOld: %(eyearOld)s<br>
ehourOld: %(ehourOld)s<br>
eminOld: %(eminOld)s<br>
startOld: %(startOld)s<br>
stopOld: %(stopOld)s<br>''' % locals()

        if command == "mainpage":
        	
        	title = "%s (Set Timer)" % self.title
	        sekunden = time.time()
	        	        
	        plusEine = sekunden
	        if start != 0:
	        	plusEine = start
	        
	        
	        # Die Zeit auf einen genauen 5 Minutenwert für die Anzeige bringen
		plusEine -= (int( time.strftime("%M", time.localtime(plusEine)) ) % 5) * 60
	
	        tag=time.strftime("%d", time.localtime(plusEine))
	        monat=time.strftime("%m", time.localtime(plusEine))
	        jahr=time.strftime("%Y", time.localtime(plusEine))
	        minute=time.strftime("%M", time.localtime(plusEine))
	        stunde=time.strftime("%H", time.localtime(plusEine))
	        
	        plusZwei = plusEine + 7200
	        if stop != 0:
	        	plusZwei = stop
	        
	        # Die Zeit auf einen genauen 5 Minutenwert für die Anzeige bringen
	        minutMinus = (int( time.strftime("%M", time.localtime(plusZwei)) ) % 5) 
	        if minutMinus != 0:
	        	minutMinus = 5 - minutMinus
	        plusZwei += minutMinus * 60
	        
	        etag=time.strftime("%d", time.localtime(plusZwei))
	        emonat=time.strftime("%m", time.localtime(plusZwei))
	        ejahr=time.strftime("%Y", time.localtime(plusZwei))
	        eminute=time.strftime("%M", time.localtime(plusZwei))
	        estunde=time.strftime("%H", time.localtime(plusZwei))
	        
	        # Umrechnung einiger Werte
	        
		
		minuteINT = int(eminute)
		minuteTMP = 5 - (minuteINT % 5)
		plusZwei += minuteTMP * 60
		eminute=time.strftime("%M", time.localtime(plusZwei))
		eminute = "%s" % str(minuteINT)
		
		o1year = ""
		o2year = ""
		for i in range(2006,2011,1):
		    iString = "%s" % i
		    if iString==jahr:
		        o1year += "			<option selected>%s</option>\n" % iString
		    else:
		        o1year += "			<option>%s</option>\n" % iString
		        
		    if iString==ejahr:
		    	o2year += "			<option selected>%s</option>\n" % iString
		    else:
		    	o2year += "			<option>%s</option>\n" % iString
		
		o1month = ""
		o2month = ""
		for i in range(1,13,1):
		    iString = "%s" % i
		    if len(iString) == 1:
		    	iString = "0%s" % iString
		    if iString == monat:
		        o1month += "<option selected>%s</option>\n" % i
		    else:
		        o1month += "<option>%s</option>\n" % i
		        
		    if iString == emonat:
		        o2month += "<option selected>%s</option>\n" % i
		    else:
		    	o2month += "<option>%s</option>\n" % i
		
		o1day = ""
		o2day = ""
		for i in range(1,32,1):
		    iString = "%s" % i
		    if len(iString) == 1:
		    	iString = "0%s" % iString
		    
		    if iString == tag:
		        o1day += "<option selected>%s</option>\n" % iString
		    else:
		        o1day += "<option>%s</option>\n" % iString
		        
		    if iString == etag:
		        o2day += "<option selected>%s</option>\n" % iString
		    else:
		    	o2day += "<option>%s</option>\n" % iString
		
		o1hour = ""
		o2hour = ""
		for i in range(0,24,1):
		    iString = "%s" % i
		    if len(iString) == 1:
		    	iString = "0%s" % iString
		    	
		    if iString == stunde:
		        o1hour += "<option selected>%s</option>\n" % iString
		    else:
		        o1hour += "<option>%s</option>\n" % iString
		        
		    if iString == estunde:
		        o2hour += "<option selected>%s</option>\n" % iString
		    else:
		    	o2hour += "<option>%s</option>\n" % iString
		
		o1minute = ""
		o2minute = ""
		for i in range(0,60,5):
		    iString = "%s" % i
		    if len(iString) == 1:
		    	iString = "0%s" % iString
		    
		    if iString == minute:
		        o1minute += "<option selected>%s</option>\n" % iString
		    else:
		        o1minute += "<option>%s</option>\n" % iString
		        
		    if iString == eminute:
		        o2minute += "<option selected>%s</option>\n" % iString
		    else:
		    	o2minute += "<option>%s</option>\n" % iString
	
		action = ""
		if action == "record":
			action = '<option value="record" selected>Record</option>\n<option value="justplay">Switch to Channel</option>'
		elif action == "justplay":
			action = '<option value="record">Record</option>\n<option value="justplay" selected>Switch to Channel</option>'
		else:
			action = '<option value="record">Record</option>\n<option value="justplay">Switch to Channel</option>'
		# Currently there are some Problems with action, so only Record is supportet
		action = '<option value="record">Record</option>'
			
		after_eventString = ""
		if after_event == "nothing":
			after_eventString = '<option selected value="nothing">Nothing</option><option value="deepstandby">Deep-Standby/Shutdown</option>'
		elif after_event == "deepstandby":
			after_eventString = '<option value="nothing">Nothing</option><option value="deepstandby" selected>Deep-Standby/Shutdown</option>'
		else:
			after_eventString = '<option value="nothing">Nothing</option><option value="deepstandby">Deep-Standby/Shutdown</option>'
		# Standby is rigth now not available in enigma2.
		#elif afterEvent == "standby":
		#	after_eventString = '<option value="nothing">Nothing</option><option value="standby" selected>Standby</option><option value="deepstandby">Deep-Standby/Shutdown</option>'
    	
	    	serviceList = ""
		# Alle bouquets
		serviceHandler = eServiceCenter.getInstance()
		list = serviceHandler.list(eServiceReference('1:7:2:0:0:0:0:0:0:0:(type == 1) || (type == 17) || (type == 195) || (type == 25) FROM BOUQUET "bouquets.tv" ORDER BY bouquet'))
		if list is not None:
			while True:
				s = list.getNext()
				if s.valid():
					service_ref = s.toString()
				
					info = serviceHandler.info(s)
					service_name = info.getName(s)
					
					serviceList += "<option value=\"0\">######## %s ########</option>\n" % service_name
					
					putTogether = string.split(str(service_ref), "FROM BOUQUET")
					searchString = "%s || (type == 17) || (type == 195) || (type == 25) FROM BOUQUET %s" % (str(putTogether[0]), str(putTogether[1]))
			
					ref_searchString = eServiceReference(searchString)
					serviceHandler2 = eServiceCenter.getInstance()
					gesamtListe = serviceHandler2.list(ref_searchString)
					if gesamtListe is not None:
						while True:
							s2 = gesamtListe.getNext()
							if s2.valid():
								service_ref2 = s2.toString()
								info2 = serviceHandler2.info(s2)
								service_name2 = info2.getName(s2)
								serviceList += "<option value=\"%s|%s\">%s</option>\n" % (service_name2, service_ref2, service_name2)
							else:
								break
				else:
					break

		repeatedString = '''
<input type="checkbox" name="mo" value="1">&nbsp;Mo&nbsp;&nbsp;
<input type="checkbox" name="tu" value="2">&nbsp;Tu&nbsp;&nbsp;
<input type="checkbox" name="we" value="4">&nbsp;We&nbsp;&nbsp;
<input type="checkbox" name="th" value="8">&nbsp;Th&nbsp;&nbsp;
<input type="checkbox" name="fr" value="16">&nbsp;Fr&nbsp;&nbsp;
<input type="checkbox" name="sa" value="32">&nbsp;Sa&nbsp;&nbsp;
<input type="checkbox" name="su" value="64">&nbsp;Su&nbsp;&nbsp;
<input type="checkbox" name="mf" value="31">&nbsp;Mo-Fr&nbsp;&nbsp;'''
		if repeated == 127:
			repeated = repeated - 127
			repeatedString = '''
<input type="checkbox" name="mo" value="1" checked>&nbsp;Mo&nbsp;&nbsp;
<input type="checkbox" name="tu" value="2" checked>&nbsp;Tu&nbsp;&nbsp;
<input type="checkbox" name="we" value="4" checked>&nbsp;We&nbsp;&nbsp;
<input type="checkbox" name="th" value="8" checked>&nbsp;Th&nbsp;&nbsp;
<input type="checkbox" name="fr" value="16" checked>&nbsp;Fr&nbsp;&nbsp;
<input type="checkbox" name="sa" value="32" checked>&nbsp;Sa&nbsp;&nbsp;
<input type="checkbox" name="su" value="64" checked>&nbsp;Su&nbsp;&nbsp;
<input type="checkbox" name="mf" value="31">&nbsp;Mo-Fr&nbsp;&nbsp;'''
		if repeated != 0:
			mo = '''<input type="checkbox" name="mo" value="1">&nbsp;Mo&nbsp;&nbsp;'''
			tu = '''<input type="checkbox" name="tu" value="2">&nbsp;Tu&nbsp;&nbsp;'''
			we = '''<input type="checkbox" name="we" value="4">&nbsp;We&nbsp;&nbsp;'''
			th = '''<input type="checkbox" name="th" value="8">&nbsp;Th&nbsp;&nbsp;'''
			fr = '''<input type="checkbox" name="fr" value="16">&nbsp;Fr&nbsp;&nbsp;'''
			sa = '''<input type="checkbox" name="sa" value="32">&nbsp;Sa&nbsp;&nbsp;'''
			su = '''<input type="checkbox" name="su" value="64">&nbsp;Su&nbsp;&nbsp;'''
			mf = '''<input type="checkbox" name="mf" value="31">&nbsp;Mo-Fr&nbsp;&nbsp;'''
			
			if repeated >= 64:
				repeated = repeated - 64
				su = '<input type="checkbox" name="su" value="64" checked>&nbsp;Su&nbsp;&nbsp;\n'
			
			if repeated == 31:
				repeated = repeated - 31
				mf = '''<input type="checkbox" name="mf" value="31" checked>&nbsp;Mo-Fr&nbsp;&nbsp;\n'''
			
			if repeated >= 32:
				repeated = repeated - 32
				sa = '<input type="checkbox" name="sa" value="32" checked>&nbsp;Sa&nbsp;&nbsp;\n'
						
			if repeated >= 16:
				repeated = repeated - 16
				fr = '<input type="checkbox" name="fr" value="16" checked>&nbsp;Fr&nbsp;&nbsp;\n'
						
			if repeated >= 8:
				repeated = repeated - 8
				th = '<input type="checkbox" name="th" value="8" checked>&nbsp;Th&nbsp;&nbsp;\n'
						
			if repeated >= 4:
				repeated = repeated - 4
				we = '<input type="checkbox" name="we" value="4" checked>&nbsp;We&nbsp;&nbsp;\n'
						
			if repeated >= 2:
				repeated = repeated - 2
				tu = '<input type="checkbox" name="Tu" value="2" checked>&nbsp;Tu&nbsp;&nbsp;\n'
					
			if repeated == 1:
				repeated = repeated - 1
				mo = '<input type="checkbox" name="mo" value="1" checked>&nbsp;Mo&nbsp;&nbsp;\n'
			
			repeatedString = mo + tu + we + th + fr + sa + su + mf
		repeatedString += '\n<input type="checkbox" id="EVERYDAY" name="EVERYDAY" value="EVERYDAY" onclick="allCheckBoxes(this.form);" />&nbsp;Every Day\n'
		
		html  = '''%(headStd)s
<script src="/webdata/WITimers.js" type="text/javascript"> </script>
	<title>%(title)s</title>
</head><body onload='selectChannel("%(ref)s", "%(refName)s");'>
<form method="GET" name="addtimer" value= "addtimer">

<table border=0 cellpadding=0 cellspacing=10>
	<tr>
		<td>Action:</td>
		<td>
			<select name="action" size="1">
			%(action)s
			</select>
		</td>
	</tr>
	<tr>
					<td>
						&nbsp;
					</td>
					<td>
						Note: For recurring events start/end day/month are not required.
					</td>
	</tr>
	<tr>
		<td>Start:</td>
		<td><select name="syear" size="1" onchange="javascript:changeYear('s');">
			%(o1year)s
		</select>.
		<select name="smonth" size="1" onchange="javascript:changeMonth('s');">
			%(o1month)s
		</select>.
		<select name="sday" size="1" onchange="javascript:changeDay('s');">
			%(o1day)s
		</select>
        	&nbsp;-&nbsp;
		<select name="shour" size="1" onchange="javascript:changeHour('s');">
			%(o1hour)s
		</select>:
		<select name="smin" size="1" onchange="javascript:changeMin('s');">
			%(o1minute)s
		</select>
		</td>
	</tr><tr>
		<td>End:</td>
		<td><select name="eyear" size="1" onchange="javascript:changeYear('e');">
			%(o2year)s
		</select>.
		<select name="emonth" size="1" onchange="javascript:changeMonth('e');">
			%(o2month)s
		</select>.
		<select name="eday" size="1" onchange="javascript:changeDay('e');">
			%(o2day)s
		</select>
        	&nbsp;-&nbsp;
		<select name="ehour" size="1" onchange="javascript:changeHour('e');">
			%(o2hour)s
		</select>:
		<select name="emin" size="1" onchange="javascript:changeMin('e');">
			%(o2minute)s
		</select>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td>Note: For one-time events the "days" field doesn't have to be specified.</td>
	</tr>
	<tr>
		<td>Days:</td>
		<td>
		%(repeatedString)s
		</td>
	</tr>
	<tr>
        	<td>Channel:</td>
		<td><select name="ref" size="1">
			%(serviceList)s
		</td>
	</tr>
	<tr>
		<td>Name:</td>
		<td><input name="name" type="text" size="100" maxlength="100" style="color: #000000;" value="%(name)s"></td>
	</tr>
	<tr>
		<td>Description:</td>
		<td><input name="descr" type="text" size="100" maxlength="100" style="color: #000000;" value="%(descr)s"></td>
	</tr>
	<tr>
		<td>After event do:</td>
		<td>
			<select name="after_event" size="1">
			%(after_eventString)s
			</select>
		</td>
	</tr>
	<tr>&nbsp;&nbsp;</tr>
        <tr>
		<td>&nbsp;</td>
		<td><input type="submit" name="send" value="Add/Save" style="width: 100px; height: 22px; color: #000000;">
		<br><input type="reset" name="clear" value="Clear" style="width: 100px; height: 22px; color: #000000;"></td>
	</tr>
</table>
%(editFields)s
</form>

<p><center><a href="/listtimers">List Timers</a></center></p>
<p><center><a href="/addtimer">Add Timers</a></center></p>
<p><center><a href="/">Main Menu</a></center></p>
<p>%(fehler)s</p>
</body></html>''' % locals()
		#print html
		return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
        else:
            title = "%s (Changes are done)" % self.title
            
            shortHtml = ""
            refreshListTimers = '<meta http-equiv="Refresh" content="5; URL=/listtimers">'
            
#	StateWaiting  = 0
#	StatePrepared = 1
#	StateRunning  = 2
#	StateEnded    = 3
            if command == "off":
            	shortHtml = "Timer was switched %s" % command
            	for x in self.sessions[0].nav.RecordTimer.timer_list:
        		if str(x.service_ref) == str(ref):
            			if start == int(x.begin):
            				if stop == int(x.end):
        					serviceref = ServiceReference(str(x.service_ref))
        					eventID = x.eit
        					begin = x.begin
        					end = x.end
        					name = x.name
        					description = x.description
        					disabled = True
        					justplay = x.justplay
	        				afterevent = x.afterEvent
        					repeated = x.repeated
            					timerEintrag = RecordTimerEntry(serviceref, begin, end, name, description, eventID, disabled, justplay, afterevent)
            					timerEintrag.repeated = repeated
            					timerEintrag.state = 3
     						
        					self.sessions[0].nav.RecordTimer.removeEntry(x)
        					self.sessions[0].nav.RecordTimer.record(timerEintrag)
        					self.sessions[0].nav.RecordTimer.saveTimer()
        					x.timeChanged()
        						
            elif command == "on":
            	shortHtml = "Timer was switched %s" % command
            	try:
        		for x in self.sessions[0].nav.RecordTimer.processed_timers + self.sessions[0].nav.RecordTimer.timer_list:
        			if str(x.service_ref) == str(ref):
            				if start == int(x.begin):
        					if stop == int(x.end):
	        					serviceref = ServiceReference(str(x.service_ref))
        						eventID = x.eit
        						begin = x.begin
        						end = x.end
        						name = x.name
        						description = x.description
        						disabled = False
        						justplay = x.justplay
	        					afterevent = x.afterEvent
        						repeated = x.repeated
            						timerEintrag = RecordTimerEntry(serviceref, begin, end, name, description, eventID, disabled, justplay, afterevent)
            						timerEintrag.repeated = repeated
       							self.sessions[0].nav.RecordTimer.removeEntry(x)
       							self.sessions[0].nav.RecordTimer.record(timerEintrag)
       							self.sessions[0].nav.RecordTimer.saveTimer()
       							x.timeChanged()
       		except:
        		etype = sys.exc_info()[0]
        		evalue = sys.exc_info()[1]
        		etb = traceback.extract_tb(sys.exc_info()[2])
        		fehler += "<p>Fehler bein einschalten:<br>(%s)<br>evalue:(%s)<br>etb:(%s)</p>" % (etype, evalue, etb)

            if command == "deleteOld" or command == "deleteOnly":
            	
            	#print "...deldeteOnly..."
            	toDelete = None
            	for x in self.sessions[0].nav.RecordTimer.timer_list + self.sessions[0].nav.RecordTimer.processed_timers:
	        	if str(x.service_ref) == str(ref):
            			if int(startOld) == int(x.begin):
        				if int(stopOld) == int(x.end):
        					toDelete = x
        	shortHtml = "Timer not found"
            	if toDelete is not None:
            		self.sessions[0].nav.RecordTimer.removeEntry(toDelete)
            		self.sessions[0].nav.RecordTimer.saveTimer()
            		shortHtml = "Timer was deleted"
            		#print "...deleted..."

            if ref == "":
            	shortHtml = "Please choose a channel"
            	refreshListTimers = ""
                        
            if shortHtml != "":
            		html  = '''%(headStd)s
	%(refreshListTimers)s
	<title>%(title)s</title>
</head><body>
<h1>%(shortHtml)s</h1>
<p><center><a href="/listtimers">List Timers</a></center></p>
<p><center><a href="/addtimer">Add Timers</a></center></p>
<p><center><a href="/">Main Menu</a></center></p>
<p>%(fehler)s</p>
</body></html>''' % locals()
			#print html
			return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
            
            if mf != 0:
            	repeated = sa + su + mf
            else:
            	repeated = mo + tu + we + th + fr + sa + su
            
            # 0: Einmal
            # 127: täglich
            # 1: wöchentlich Montag
            # 2: wöchentlich Dienstag
            # 4: wöchentlich Mitwoch
            # 8: wöchentlich Donnerstag
            # 16: wöchentlich Freitag
            # 32: wöchentlich Samstag
            # 64: wöchentlich Sonntag
            # 31: montag bsi freitag

            afterevent = None
            if after_event == "nothing":
            	afterevent = AFTEREVENT.NONE
            if after_event == "standby":
            	afterevent = AFTEREVENT.STANDBY
            if after_event == "deepstandby":
            	afterevent = AFTEREVENT.DEEPSTANDBY

            eventid = None
            disabled = False
            justplay = False
            if action == "justplay":
            	justplay = True

            if ref is not None:
            	timerEintrag = None
       		serviceref = ServiceReference(ref)

		timerEintrag = RecordTimerEntry(serviceref, start, stop, name, descr, eventid, disabled, justplay, afterevent)
            	timerEintrag.repeated = repeated
            	
            	try: 
	        	if (not(self.sessions[0].nav.RecordTimer.isInTimer(eventid,start,stop-start,ref))):
				self.sessions[0].nav.RecordTimer.record(timerEintrag)
				self.sessions[0].nav.RecordTimer.saveTimer()
				timerEintrag.timeChanged()

		except:
            		etype = sys.exc_info()[0]
            		evalue = sys.exc_info()[1]
            		etb = traceback.extract_tb(sys.exc_info()[2])
            		fehler += "<p>Fehler beim speichern descr Timer-Eintrags:(%s), evalue:(%s), etb:(%s)</p>" % (etype, evalue, etb)
            	
            htmlok  = '''%(headStd)s
	<meta http-equiv="Refresh" content="5; URL=/listtimers">
	<title>%(title)s</title>
</head><body>
<h1>The Timer shoud be set</h1>
<p><center><a href="/listtimers">List Timers</a></center></p>
<p><center><a href="/addtimer">Add Timers</a></center></p>
<p><center><a href="/">Main Menu</a></center></p>
<p>%(fehler)s</p>
</body></html>''' % locals()

            if command == "help":
            	html = '''
anlegen eines neuen Timers:
addtimer?command=save&action=record
 &name=<Name der Sendung>&descr=<Beschreibung der Sendung>&ref=<Name|Referenz>
 &syear=<Start-Jahr>&smonth=<Start-Monat>&sday=<Start-Tag>&shour=<Start-Stunde>&smin=<Start-Minute>
 &eyear=<Stop-Jahr>&emonth=<Stop-Monat>&eday=<Stop-Tag>&ehour=<Stop-Stunde>&emin=<Stop-Minute>
 &mo=<1(immer Montags)>&tu=<2(immer Dienstags)>&we=<4(immer Mittwochs)>&th=<8(immer Donnerstags)>
 &fr=<16(immer Freitags)>&sa=<32(immer Samstags)>&su=<64(immer Sonntags)>&mf=<31(Montag bis Freitag)>

loeschen:
http://192.168.178.21/addtimer?command=deleteOnly&ref=1:0:1:2EF4:441:1:C00000:0:0:0:&startOld=1165254900&stopOld=1165259614
addtimer?command=deleteOnly&ref=<Referenz>&startOld=<Start-Zeit in Sekunden>&stopOld=<End-Zeit in Sekunden>
	alternativ
addtimer?command=deleteOnly&ref=<Referenz>
 &syearOld=<Start-Jahr>&smonthOld=<Start-Monat>&sdayOld=<Start-Tag>&shourOld=<Start-Stunde>&sminOld=<Start-Minute>
 &eyearOld=<Stop-Jahr>&emonthOld=<Stop-Monat>&edayOld=<Stop-Tag>&ehourOld=<Stop-Stunde>&eminOld=<Stop-Minute>
'''

            #print htmlok
            return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=htmlok)


class ListTimers(resource.Resource):
    
    title = "ListTimers by jjbig (v%s)" % version
    sessions = [ ]
    
    headStd = '''<html><head>
	<link href="/webdata/theme.css" type="text/css" rel="stylesheet"></link> 
	<meta content="text/html; charset=UTF-8" http-equiv="content-type">
	<meta content="no-cache" http-equiv="pragma">
	<meta content="0" http-equiv="expires">
	<meta content="no-cache" http-equiv="cache-control">'''
    
    def __init__(self,sessions):
    	self.sessions=sessions
        
    def render(self, req):
        """ rendering server response """
        title = self.title
        command = req.args.get("action",None)
        
        fehler = ""
        html = ""
        headStd = self.headStd
        sekunden = time.time()

        liste = ""
        for x in self.sessions[0].nav.RecordTimer.timer_list + self.sessions[0].nav.RecordTimer.processed_timers:
			name = x.name
			service_ref = x.service_ref
			descr = x.description
			start = x.begin
			stop = x.end
			eventid = x.eit
			#action = x.justplay
			state = x.state
			disabled = x.disabled
			afterEventString = "Nothing"
			afterEventStringSmall = "nothing"
			repeatedString = "Only Once"
			repeated = int(x.repeated)
			repeatedI = "%s" % repeated
			dstart = time.asctime(time.localtime(start))
			dstop  = time.asctime(time.localtime(stop))
						
			# D5DCE4: Normal recording 		disable(False), state(0)
			# CCFFFF: Recording switched off	disable(True), state(3)
			# 8BDCE4: Recording already done	disable(False), state(3)
			# CC3333: Recording in progresss	disable(False), state(0), x.record_service != None

			on_off = "off"
			on_offString = '<img src="/webdata/gfx/off.png" alt="switch off entry" width="20" height="20" border="0" title="switch off entry">'
			on_offColor = "D5DCE4"
			
			# Wenn der Timer disable ist gibt es zwei Moeglichkeiten
			# a) erst ist disabled, b) er ist schon aufgenommen und descrhalb
			# disabled...
			if state == 3:
				if disabled == False:
					on_offColor = "8BDCE4"
				else:
					on_offColor = "CCFFFF"
					on_off = "on"
					on_offString = '<img src="/webdata/gfx/on.png" alt="switch on entry" width="20" height="20" border="0" title="switch on entry">'

			if x.record_service is not None:
				on_offColor = "CC3333"

			action = ""
			if x.justplay == True:
				action = "justplay"
			else:
				action = "record"
			
			try:
				afterEvent = x.afterEvent
				if afterEvent == AFTEREVENT.DEEPSTANDBY:
					afterEventString = "Deepstandby/Shutdown"
					afterEventStringSmall = "deepstandby"
				if afterEvent == AFTEREVENT.STANDBY:
					afterEventString = "Standby"
					afterEventStringSmall = "standby"
				if afterEvent == AFTEREVENT.NONE:
					afterEventString = "Nothing"
					afterEventStringSmall = "nothing"

				
				if repeated != 0:
					ev = ""
					mo = ""
					tu = ""
					we = ""
					th = ""
					fr = ""
					su = ""
					sa = ""
					mf = ""
									
					if repeated == 127:
						repeated = repeated - 127
						ev = "Every Day"
					if repeated >= 64:
						repeated = repeated - 64
						su = "Su "
					if repeated >= 32:
						repeated = repeated - 32
						sa = " Sa "
					if repeated == 31:
						repeated = repeated - 31
						mf = "Mo-Fr"
					if repeated >= 16:
						repeated = repeated - 16
						fr =  " Fr "
					if repeated >= 8:
						repeated = repeated - 8
						th = " Th "
					if repeated >= 4:
						repeated = repeated - 4
						we = " We "
					if repeated >= 2:
						repeated = repeated - 2
						tu = " Tu "
					if repeated == 1:
						repeated = repeated - 1
						mo =  " Mo "
					if ev == "":
						repeatedString = mo + tu + we + th + fr + sa + su + mf
						#dstart = ""
						#dstop = ""
					else:
						repeatedString = ev
						
						
			except:
				etype = sys.exc_info()[0]
	        		evalue = sys.exc_info()[1]
	        		etb = traceback.extract_tb(sys.exc_info()[2])
	        		fehler += "<p>Afterevent und repeated:<br>(%s)<br>evalue:(%s)<br>etb:(%s)</p>" % (etype, evalue, etb)

			serviceRef = service_ref
			assert isinstance(serviceRef, ServiceReference)
			channel = str( serviceRef.getServiceName() )

			liste += '''<tr bgcolor="#%(on_offColor)s">
	<td><font color="#000000">%(channel)s</font></td>
		<!-- (%(state)s)[%(disabled)s] -->
		<td><font color="#000000">%(name)s</font></td>
		<td><font color="#000000">%(descr)s</font></td>
		<td><font color="#000000">%(repeatedString)s</font></td>
		<td><font color="#000000">%(dstart)s</font></td>
		<td><font color="#000000">%(dstop)s</font></td>
		<td><font color="#000000">%(afterEventString)s</font></td>
	<td><a href="addtimer?command=mainpage&name=%(name)s&repeated=%(repeatedI)s&ref=%(service_ref)s&descr=%(descr)s&start=%(start)s&stop=%(stop)s&id=%(eventid)s&action=%(action)s&afterevent=%(afterEventStringSmall)s"><img src="/webdata/gfx/edit.gif" alt="edit entry" width="20" height="20" border="0" title="edit entry"></a>
	<a href="addtimer?command=deleteOnly&ref=%(service_ref)s&startOld=%(start)s&stopOld=%(stop)s"><img src="/webdata/gfx/trash.gif" alt="Delete entry" width="20" height="20" border="0" title="delete entry"></a>
	<a href="addtimer?command=%(on_off)s&ref=%(service_ref)s&start=%(start)s&stop=%(stop)s">%(on_offString)s</a></td>
</tr>''' % locals()
				
        if liste == "":
        	liste = '''<tr bgcolor="#D5DCE4"><td colspan="6" align="center">No active timers found ...</td></tr>'''

        html  = '''%(headStd)s
	<title>%(title)s</title>
</head><body>
<table border="0" align="center">
<tr bgcolor="#63699C">
<td><font color="#FFFFFF">Channel</font></td>
<td><font color="#FFFFFF">Name</font></td>
<td><font color="#FFFFFF">Description</font></td>
<td><font color="#FFFFFF">Repeated</font></td>
<td><font color="#FFFFFF">Start Time</font></td>
<td><font color="#FFFFFF">End Time</font></td>
<td><font color="#FFFFFF">After Event</font></td>
<td align="center"><font color="#FFFFFF">Options</font></td>
</tr>
%(liste)s
</table>
<p>Legend:</p>
<table border="0" align="left">
<tr bgcolor="#D5DCE4">
<td><font color="#000000">Normal recording</font></td>
</tr>
<tr bgcolor="#CCFFFF">
<td><font color="#000000">Recording switched off</font></td>
</tr>
<tr bgcolor="#8BDCE4">
<td><font color="#000000">Recording already done</font></td>
</tr>
<tr bgcolor="#CC3333">
<td><font color="#000000">Recording in progress</font></td>
</tr>
</table>

</form>
<p align="center"><a href="/addtimer">Add New Timer</a><p>
<p><center><a href="/">Main Menu</a></center></p>
<p>%(fehler)s</p>
</body></html>
        ''' % locals()

        #print html
        return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
            
