# WebX TV by gutemine, homey and others ...
# Sppecial Thanks to 3c5x9 ;-)
from twisted.internet import reactor
from twisted.web2 import server, channel, static, resource, stream, http_headers, responsecode, http

from Components.config import config
from ServiceReference import ServiceReference
from enigma import iServiceInformation
import os

__version__ = "0.9"

class WebXTV(resource.Resource):
    
    title = "DreamBox 7025 - Web-X-TV"
    sessions = [ ]
    
    def __init__(self,sessions):
    	self.sessions=sessions
        
    def render(self, req):
    	# Ouch! Killing all running stream processes
    	os.system("killall -9 streamts")
    	
    	#Get Network IP
    	def ConvertIP(AddStr):
			retstr = AddStr.replace(', ','.')
			retstr = retstr.replace('[','')
			retstr = retstr.replace(']','')
			return retstr

    	LAN_ip = ConvertIP(_("%s") % config.network.ip.value)
    	
    	#Get CurrentService Info
    	service = self.sessions[0].nav.getCurrentService()
    	
    	if self.sessions[0].nav.getCurrentlyPlayingServiceReference() is not None:
			svName = ServiceReference(self.sessions[0].nav.getCurrentlyPlayingServiceReference()).getServiceName()
    	else:
			svName = "N/A"
    	
    	if service is not None:
           serviceinfo = service.info()
           VPID = hex(serviceinfo.getInfo(iServiceInformation.sVideoPID))
           APID = hex(serviceinfo.getInfo(iServiceInformation.sAudioPID))
           PPID = hex(serviceinfo.getInfo(iServiceInformation.sPMTPID))

           html  = "<html><head><title>%s</title><link href=\"/webdata/theme.css\" type=\"text/css\" rel=\"stylesheet\"></link><script type=\"text/javascript\" src=\"/webdata/vlcplayer.js\"></script></head>" %self.title
           html += "<body>" 
           html += "<table align=\"center\" border=\"0\" width=\"100%\">"
           html += "<tr>"
           html += "<td align=\"center\">"
           html += "<div align=\"center\" id=\"vlcplayer\" style=\"margin:30px auto 0 auto; background:transparent url(/webdata/gfx/vlcskin.png) no-repeat scroll top center; width:800px; height:675px;\"></br><a target=\"_blank\" href=\"http://%s:31339/0,%s,%s,%s\"><b>Channel:</b> %s <b>vpid:</b> %s <b>apid:</b> %s <b>ppid:</b> %s</a><script type=\"text/javascript\">buildplayer(\'http://%s:31339/0,%s,%s,%s\', 780, 585);</script></div></br><p align=\"center\"><a href=\"javascript:location.reload(true)\">Refresh this page</a></p>" % (LAN_ip,PPID.lstrip("0x"),VPID.lstrip("0x"),APID.lstrip("0x"),svName,PPID.lstrip("0x"),VPID.lstrip("0x"),APID.lstrip("0x"),LAN_ip,PPID.lstrip("0x"),VPID.lstrip("0x"),APID.lstrip("0x"))
           html += "</td>"
           html += "</tr>"
           html +="</table>"
           html +="</body>"
           html +="</html>"

           return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
           
    	else:
           html  = "<html><head><title>%s</title><link href=\"/webdata/theme.css\" type=\"text/css\" rel=\"stylesheet\"></link><script type=\"text/javascript\" src=\"/webdata/vlcplayer.js\"></script></head>" %self.title
           html += "<body>" 
           html += "<table align=\"center\" border=\"0\" width=\"100%\">"
           html += "<tr>"
           html += "<td align=\"center\">"
           html += "Could not get required PIDs for streaming ..."
           html += "</td>"
           html += "</tr>"
           html +="</table>"
           html +="</body>"
           html +="</html>"

           return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
           