#First steps from Einsteini in python
#Thx to 3c5x9,gutemine and Homey[GER]
#getpid delivers the whole path
#including pids and ip-address 
#needed for starting vlc

from twisted.internet import reactor
from twisted.web2 import server, channel, static, resource, stream, http_headers, responsecode, http
from enigma import iServiceInformation
from Components.config import config

import os
__version__ = "0.1"
class getpid(resource.Resource):
   
    title = "GetPid v. 0.1 by Einsteini"
    sessions = [ ]
    
    def __init__(self,sessions):
    	self.sessions=sessions

    def render(self, req):
        """ rendering server response """
        def convertString(IPString):
             retrstr = IPString.replace(', ','.')
             retrstr = retrstr.replace('[','')
             retrstr = retrstr.replace(']','')
             return retrstr
             
        ETHIP = convertString(_("%s") % config.network.ip.value)
        
        
        command = req.args.get("transponders",None)
	pids = self.sessions[0].nav.getCurrentService()
	if pids is not None:
           pidinfo = pids.info()
           VPID = hex(pidinfo.getInfo(iServiceInformation.sVideoPID))
           APID = hex(pidinfo.getInfo(iServiceInformation.sAudioPID))
           PPID = hex(pidinfo.getInfo(iServiceInformation.sPMTPID))
	   pidstring = "%s,%s,%s" % (PPID.lstrip("0x"),VPID.lstrip("0x"),APID.lstrip("0x"))

           html  = "<html><head><title>%s</title></head>" %self.title
           html += "http://%s:31339/0,%s" % (ETHIP,pidstring) 

        if command is None:
           return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
        else:   
           ServiceTest = pidinfo.getInfo(iServiceInformation.sProvider)
           ServiceString = "%s" % ServiceTest
           html = "<html><head><title>%s</title></head>" %self.title
           html += "%s" % ServiceTest  
           return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)















































