#gutemine
from WIRemoteControl import *
from WIMessage import *
from WIWebXTV import *
#Homey
from WIBoxInfo import *
from WIShutDown import *
from WIMoviePlayer import *
#jjbig
from WITimers import *
from WIPassword import *
#Seddi
from GrabResource import  *
#Einsteini
from WIgetpid import *
#3c5x9
from Plugins.Plugin import PluginDescriptor
from twisted.internet import reactor
from twisted.web2 import server, channel, static, resource, stream, http_headers, responsecode, http
from twisted.python import util
import webif
import os, re

sessions = [ ]

def startWebserver():
	class ScreenPage(resource.Resource):
		def __init__(self, path):
			self.path = path
			
		def render(self, req):
			global sessions
			if sessions == [ ]:
				return http.Response(200, stream="please wait until enigma has booted")

			class myProducerStream(stream.ProducerStream):
				closed_callback = None

				def close(self):
					if self.closed_callback:
						self.closed_callback()
					stream.ProducerStream.close(self)

			s = myProducerStream()
			webif.renderPage(s, self.path, req, sessions[0])  # login?

			return http.Response(stream=s)

		def locateChild(self, request, segments):
			path = '/'.join(["web"] + segments)
			if path[-1:] == "/":
				path += "index.html"

			path += ".xml"
			return ScreenPage(path), ()

	class Toplevel(resource.Resource):
		
		addSlash = True

		def render(self, req):
			html='<html><head><tilte></title><link href="/webdata/theme.css" rel="stylesheet" type="text/css" /></head><body><h1>Enigma2 Webinterface</h1>'
			html +="""<ul>
						<li><a href="/web/">Webinterface</a></li>
						</ul>
						<ul>
						<li><a href="/listtimers">List/Change Timers</a></li>
						<li><a href="/remote">Remote Control</a></li>
						<li><a href="/grab">Screenshot</a></li>
						<li><a href="/webxtv">Web X-TV</a></li>
						<li><a href="/message">Message Box</a></li>
						<li><a href="/shutdown">ShutDown</a></li>
						<li><a href="/getpid">Get VLC PIDS</a></li>
						<li><a href="/password">Password</a></li>
					</ul>"""
			html +="</body></html>"
			return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream =html)

		child_web = ScreenPage("/")
		child_hdd = static.File("/hdd")
		child_remote = RemoteControl()
		child_message = Message(sessions)
		child_webxtv = WebXTV(sessions)
		
		child_password = SetPassword(sessions)

		child_listtimers = ListTimers(sessions)
		child_addtimer = AddTimer(sessions)

		child_boxinfo = BoxInfo(sessions)
		child_movieplayer = MoviePlayer(sessions)
		child_shutdown = ShutDown()

		child_getpid = getpid(sessions)

		child_grab =GrabResource()
		child_webdata = static.File(util.sibpath(__file__, "web-data")) # FIXME: web-data appears as webdata

	if os.path.exists("/etc/wipasswd") == True:
		passwdfile = open("/etc/wipasswd","r")
	   	password = passwdfile.read()
	   	passwdfile.close()
	   	password = str( re.sub(r'^\s+$|\n', '', password) )
	   	#print "file exists (%s)" % password
   	
	   	if password != "":
	   		from twisted.cred.portal import Portal
			from twisted.cred import checkers
			from twisted.web2.auth import digest, basic, wrapper
			
			#print "file nicht leer"
	   
			portal = Portal(HTTPAuthRealm())
			checker = checkers.InMemoryUsernamePasswordDatabaseDontUse()
                        checker.addUser("WIdreambox",password)
			portal.registerChecker(checker)
			pw = 'Enter User And Password For DM7025'
#			root = wrapper.HTTPAuthResource(Toplevel(), (basic.BasicCredentialFactory('DM7025'),digest.DigestCredentialFactory('sha','DM7025')), portal, (IHTTPUser,))
			root = wrapper.HTTPAuthResource(Toplevel(), (basic.BasicCredentialFactory(pw),), portal, (IHTTPUser,))
			site = server.Site(root)
		else:
	   		site = server.Site(Toplevel())
        else:
			site = server.Site(Toplevel())
	reactor.listenTCP(80, channel.HTTPFactory(site))

	    	
def autostart(reason, **kwargs):
	if "session" in kwargs:
		global sessions
		sessions.append(kwargs["session"])
		return

	if reason == 0:
		#try:
			#f = open("/tmp/logfile.log", 'w')
			#from twisted.python.log import startLogging
			#startLogging(f)
			startWebserver()
		#except Exception,e:
		#	print e
####################
####################
from zope.interface import Interface, implements
from twisted.cred import portal

class IHTTPUser(Interface):
    pass

class HTTPUser(object):
    implements(IHTTPUser)

class HTTPAuthRealm(object):
    implements(portal.IRealm)

    def requestAvatar(self, avatarId, mind, *interfaces):
        if IHTTPUser in interfaces:
            return IHTTPUser, HTTPUser()

        raise NotImplementedError("Only IHTTPUser interface is supported")

#############################

#############################
def Plugins(**kwargs):
	return PluginDescriptor(where = [PluginDescriptor.WHERE_SESSIONSTART, PluginDescriptor.WHERE_AUTOSTART], fnc = autostart)



































